#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
extern "C"
void findPivots(float **, int*, int n);
void findPivotsD(double **, int*, int n);
void inverseD(double **,double **, int n);
//void inverse(float **, float **,int n);
void randomInit(float**, int);


/*int
main(int argc, char** argv)
{
    // set seed for rand()
    srand(2007);
    int size = 8;
    int i,j;
    float ** h_A;
    float ** reference;
    // allocate host memory for matrices A and B
    
    h_A = (float **) malloc(size*sizeof(float *));
    reference = (float **) malloc(size*sizeof(float *));
    for (i=0; i < size; i++) {
       h_A[i] = (float *) malloc(size*sizeof(float));
       reference[i] = (float *) malloc(size*sizeof(float));
    }
    clock_t start_time = clock();
    for (i=0;i<24000;i++) {
    randomInit(h_A,size);
    inverse(h_A,reference,size);
    }
    

    return 0;
}*/

void inverse(float** a,float ** x,int n) 
{
   int i,j,k;
   int * indx;
   float ** b;
   indx = (int *) malloc(n*sizeof(int));
   b = (float **) malloc(n*sizeof(float *));

   for (i=0; i < n; i++) {
      b[i] = (float *) malloc(n*sizeof(float));
   }

   for (i = 0; i < n; ++i) {
      for (j = 0; j < n; ++j) {
         b[i][j] = 0;
      }
   }
   for (i = 0; i < n; ++i) {
      b[i][i] = 1;
   }

   findPivots (a,indx,n);

   for (i = 0; i < n-1; ++i) {
      for (j = i+1; j < n; ++j) {
         for (k = 0; k < n; ++k) {
            b[indx[j]][k] = b[indx[j]][k]-a[indx[j]][i]*
                            b[indx[i]][k];
         }
      }
   }

   for (i = 0; i < n; ++i) {
      x[n-1][i] = b[indx[n-1]][i]/a[indx[n-1]][n-1];
      for (j = n-2; j >= 0; j = j-1) {
         x[j][i] = b[indx[j]][i];
         for (k = j+1; k < n; ++k) {
            x[j][i] = x[j][i]-a[indx[j]][k]*x[k][i];
         }
         x[j][i] = x[j][i]/a[indx[j]][j];
      }
   }

   for (i=0; i < n; i++) {
      free(b[i]);
   }
   free(b);
   free(indx);
}

void findPivots (float **a,int *indx, int n) {

  int i, j, k, itmp;
  float c1, pi, pi1, pj;
  float * c;
  c = (float *) malloc(n*sizeof(float));
  k=0;

  // Initialize the index 
  for (i = 0; i < n; ++i) {
      indx[i] = i;
  }

  // Find the rescaling factors, one from each row
  for (i = 0; i < n; ++i) {
     c1 = 0;
     for (j = 0; j < n; ++j) {
        if (fabs(a[i][j]) > c1) {
          c1 = fabs(a[i][j]);
        }
     }
     c[i] = c1;
  }

  // Search the pivoting (largest) element from each column 

  for (j = 0; j < n-1; ++j) {
     pi1 = 0;
     for (i = j; i < n; ++i) {
        pi = fabs(a[indx[i]][j])/c[indx[i]];
        if (pi > pi1) {
           pi1 = pi;
           k = i;
        }
     }

   // Interchange the rows via indx[] to record pivoting order

     itmp = indx[j];
     indx[j] = indx[k];
     indx[k] = itmp;
     for (i = j+1; i < n; ++i) {
        pj = a[indx[i]][j]/a[indx[j]][j];

   // Record pivoting ratios below the diagonal

        a[indx[i]][j] = pj;

   // Modify other elements accordingly

        for (k = j+1; k < n; ++k) {
           a[indx[i]][k] = a[indx[i]][k]-pj*a[indx[j]][k];
        }
     }
  }

  free(c);
}

void inverseD(double** a,double ** x,int n) 
{
   int i,j,k;
   int * indx;
   double ** b;
   indx = (int *) malloc(n*sizeof(int));
   b = (double **) malloc(n*sizeof(double *));

   for (i=0; i < n; i++) {
      b[i] = (double *) malloc(n*sizeof(double));
   }

   for (i = 0; i < n; ++i) {
      for (j = 0; j < n; ++j) {
         b[i][j] = 0;
      }
   }
   for (i = 0; i < n; ++i) {
      b[i][i] = 1;
   }

   findPivotsD (a,indx,n);

   for (i = 0; i < n-1; ++i) {
      for (j = i+1; j < n; ++j) {
         for (k = 0; k < n; ++k) {
            b[indx[j]][k] = b[indx[j]][k]-a[indx[j]][i]*
                            b[indx[i]][k];
         }
      }
   }

   for (i = 0; i < n; ++i) {
      x[n-1][i] = b[indx[n-1]][i]/a[indx[n-1]][n-1];
      for (j = n-2; j >= 0; j = j-1) {
         x[j][i] = b[indx[j]][i];
         for (k = j+1; k < n; ++k) {
            x[j][i] = x[j][i]-a[indx[j]][k]*x[k][i];
         }
         x[j][i] = x[j][i]/a[indx[j]][j];
      }
   }

   for (i=0; i < n; i++) {
      free(b[i]);
   }
   free(b);
   free(indx);
}

void findPivotsD (double **a,int *indx, int n) {

  int i, j, k, itmp;
  double c1, pi, pi1, pj;
  double * c;
  c = (double *) malloc(n*sizeof(double));
  k=0;

  // Initialize the index 
  for (i = 0; i < n; ++i) {
      indx[i] = i;
  }

  // Find the rescaling factors, one from each row
  for (i = 0; i < n; ++i) {
     c1 = 0;
     for (j = 0; j < n; ++j) {
        if (fabs(a[i][j]) > c1) {
          c1 = fabs(a[i][j]);
        }
     }
     c[i] = c1;
  }

  // Search the pivoting (largest) element from each column 

  for (j = 0; j < n-1; ++j) {
     pi1 = 0;
     for (i = j; i < n; ++i) {
        pi = fabs(a[indx[i]][j])/c[indx[i]];
        if (pi > pi1) {
           pi1 = pi;
           k = i;
        }
     }

   // Interchange the rows via indx[] to record pivoting order

     itmp = indx[j];
     indx[j] = indx[k];
     indx[k] = itmp;
     for (i = j+1; i < n; ++i) {
        pj = a[indx[i]][j]/a[indx[j]][j];

   // Record pivoting ratios below the diagonal

        a[indx[i]][j] = pj;

   // Modify other elements accordingly

        for (k = j+1; k < n; ++k) {
           a[indx[i]][k] = a[indx[i]][k]-pj*a[indx[j]][k];
        }
     }
  }

  free(c);
}
void randomInit(float** data, int size)
{
    for (int i = 0; i < size; i++) {
       for (int j=0; j<size; j++) {
          data[j][i] = rand() / (float)RAND_MAX;
       }
    }
}
